## fis-gtm 7.0

=== CMakeLists.txt ===
#################################################################
#								#
# Copyright (c) 2012-2022 Fidelity National Information		#
# Services, Inc. and/or its subsidiaries. All rights reserved.	#
#								#
#	This source code contains the intellectual property	#
#	of its copyright holder(s), and is made available	#
#	under a license.  If you do not know the terms of	#
#	the license, please stop and do not read further.	#
#								#
#################################################################

# Min version of cmake on RHEL 6
cmake_minimum_required(VERSION 3.6.0)
if(POLICY CMP0087)
  # Policy needed since cmake 3.16
  cmake_policy(SET CMP0087 NEW)
endif()
project(GTM C ASM)

# Max optimization level is -O2
get_property(languages GLOBAL PROPERTY ENABLED_LANGUAGES)
foreach(lang ${languages})
  get_property(flags CACHE CMAKE_${lang}_FLAGS_RELEASE PROPERTY VALUE)
  if("${flags}" MATCHES "-O[3-9]")
    string(REGEX REPLACE "-O[3-9]" "-O2" flags "${flags}")
    set_property(CACHE CMAKE_${lang}_FLAGS_RELEASE PROPERTY VALUE "${flags}")
  endif()
endforeach()

# Defaults
set(version ${V7.0-005})
if("${version}" STREQUAL "")
        set(version V9.9-0)
endif()

# If CMAKE_BUILD_TYPE is not defined make it a Release build
if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type" FORCE)
endif()

if(GTM_RELEASE_NAME)
  add_definitions(-DGTM_RELEASE_NAME="${GTM_RELEASE_NAME}")
endif()

# Enable GT.M debug options unless directed not to enable them. Added to build without whitebox tests.
set(GTM_ENABLE_DEBUG 1 CACHE BOOL "Enable GT.M debug options")
if(GTM_ENABLE_DEBUG)
  set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DDEBUG")
endif()

if ( CMAKE_COMPILER_IS_GNUCC )
    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -Wall -Wno-unused-result -Wno-parentheses -Wno-unused-value -Wno-unused-variable")
    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -Wno-maybe-uninitialized -Wno-char-subscripts -Wno-unused-but-set-variable")
    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -Wno-unused-function")
endif()

set(install_permissions_script
  OWNER_READ OWNER_EXECUTE OWNER_WRITE
  GROUP_READ GROUP_EXECUTE
  WORLD_READ WORLD_EXECUTE
  )

if(CMAKE_VERSION VERSION_LESS 3.0.0)
    set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_DEBUG DEBUG)
else()
    set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS $<$<CONFIG:Debug>:DEBUG>)
endif()

# Only IA64 and x86_64 architectures use this option
set(gen_xfer_desc 0)

# Platform specific libs
set(gtm_osarch_libs "")

# Define these ahead of establishing platforms
set(gt_src_list gen)
set(sources_used "")
set(extralibs "")
message("--> OS = ${CMAKE_SYSTEM_NAME} / ARCH = ${CMAKE_SYSTEM_PROCESSOR}")
# Establish platform
# Except for Solaris, CMAKE_COMPILER_IS_GNUCC is true
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  include(sr_linux/platform.cmake)
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "AIX")
  include(sr_aix/platform.cmake)
else()
  message(FATAL_ERROR "--> OS = ${CMAKE_SYSTEM_NAME} / ARCH = ${CMAKE_SYSTEM_PROCESSOR}")
endif()

# Choose where to get bootstrap sources.
set(GTM_DIST "" CACHE PATH "Existing GT.M Distribution")
if(GTM_DIST)
  # Bootstrap using already-installed mumps.
  message(STATUS "Using existing gtm_dist=${GTM_DIST} to generate sources.")
  set(gen_bootstrap 1)
  set(gen_bootstrap_dist "${GTM_DIST}")
  set(gen_bootstrap_mumps "${GTM_DIST}/mumps")
  set(gen_bootstrap_depend "${gen_bootstrap_mumps}")
else()
  # Bootstrap using pre-generated bootstrap sources.
  # We generate them again only for comparison.
  message(STATUS "Bootstraping from pre-generated sources.")
  set(gen_bootstrap 0)
  set(gen_bootstrap_dist "${GTM_BINARY_DIR}")
  set(gen_bootstrap_mumps "$<TARGET_FILE:mumps>")
  set(gen_bootstrap_depend mumps)
endif()

set(GTM_INSTALL_DIR lib/fis-gtm/${version}_${arch} CACHE STRING "Install directory (under CMAKE_PREFIX_PATH if relative)")
if(NOT GTM_INSTALL_DIR)
  set(GTM_INSTALL_DIR .)
endif()

#-----------------------------------------------------------------------------

# Source files are organized into subdirectories named by platform.
# Store in 'gt_src_list' a list of directory names selected and
# ordered based on the target platform.  A given source file name may
# appear in multiple directories but only the instance found earliest
# in the search path will be used.  Later instances of the same source
# file name will be ignored.
list(APPEND gt_src_list
  sr_unix_gnp
  sr_unix_cm
  sr_unix
  sr_port_cm
  sr_port
  )

# Collect the source file names belonging to each directory.  Store
# the full path to a directory in 'source_dir_${d}' and the list of
# source file names in the directory in 'sources_${d}'.
foreach(d ${gt_src_list})
  set(source_dir_${d} ${GTM_SOURCE_DIR}/${d})
  file(GLOB sources_${d} RELATIVE ${source_dir_${d}}
	  ${d}/*.c ${d}/*.s ${d}/*.si ${d}/*.txt)
endforeach()
# Prefer generated sources over all other locations.
file(MAKE_DIRECTORY ${GTM_BINARY_DIR}/gen)
set(source_dir_gen ${GTM_BINARY_DIR}/gen)
# Hard-code list since we cannot glob files that do not exist.
set(sources_gen gtm_threadgbl_deftypes.h gtm_threadgbl_deftypes_asm.si)
if(gen_bootstrap)
  set(sources_gen ${sources_gen} cmerrors_ctl.c cmierrors_ctl.c gdeerrors_ctl.c merrors_ctl.c ttt.c)
endif()

# The C preprocessor include search path consists of every source
# directory ordered by 'gt_src_list'.
set(includes ${GTM_BINARY_DIR}/gen)
foreach(d ${gt_src_list})
  file(RELATIVE_PATH d_REL ${CMAKE_CURRENT_SOURCE_DIR} ${source_dir_${d}}/.)
  list(APPEND includes ${d_REL})
endforeach()
include_directories(${includes})
# We generate some uniquely-named headers in the top of the build tree.
include_directories(${GTM_BINARY_DIR})

# Function to select the first instance of a given source file name
# found in the ordered 'gt_src_list' search path.
function(select_file src_var name)
  set(found "")
  foreach(d ${gt_src_list})
    set(src "${source_dir_${d}}/${name}")
    if(EXISTS "${src}")
      set(found "${src}")
      break()
    endif()
  endforeach()
  if(NOT found)
    message(FATAL_ERROR "Cannot find \"${name}\" as ${ARGN}")
  endif()
  set("${src_var}" "${found}" PARENT_SCOPE)
endfunction()

# Macro to search directories ordered by 'gt_src_list' for a given
# list of source file names, assign them to a target, and exclude the
# source file names from inclusion in libmumps.
macro(set_source_list target)
  foreach(name ${ARGN})
    set(src "")
    foreach(d ${gt_src_list})
      if(";${sources_${d}};" MATCHES ";(${name}\\.(c|s|si));")
      	set(fname ${CMAKE_MATCH_1})
	set(src ${d}/${fname})
	set("source_used_${fname}" 1)
	list(APPEND sources_used ${source_dir_${d}}/${fname})
	break()
      endif()
    endforeach()
    if(src)
      list(APPEND ${target}_SOURCES ${src})
    else()
      message(FATAL_ERROR "No source \"${name}\" available!")
    endif()
  endforeach()
endmacro()

# Macro like set_source_list but that loads the list of source file
# names from a file.
macro(load_source_list target listfile)
  file(STRINGS "${listfile}" names)
  set_source_list(${target} ${names})
endmacro()

#-----------------------------------------------------------------------------

# Assign sources to libraries.
load_source_list(libcmisockettcp sr_unix_gnp/libcmisockettcp.list)
load_source_list(libdse          sr_unix/libdse.list)
load_source_list(libgnpclient    sr_unix_gnp/libgnpclient.list)
load_source_list(libgnpserver    sr_unix_gnp/libgnpserver.list)
load_source_list(libgtcm         sr_unix_cm/libgtcm.list)
load_source_list(liblke          sr_unix/liblke.list)
load_source_list(libmupip        sr_unix/libmupip.list)
load_source_list(libstub         sr_unix/libstub.list)

# Assign sources to executables.
set_source_list(gtm_threadgbl_deftypes gtm_threadgbl_deftypes)
set_source_list(dse              dse dse_cmd)
set_source_list(gtcm_gnp_server  gtcm_gnp_server)
set_source_list(gtcm_pkdisp      gtcm_pkdisp)
set_source_list(gtcm_play        gtcm_play omi_srvc_xct)
set_source_list(gtcm_server      gtcm_main omi_srvc_xct)
set_source_list(gtcm_shmclean    gtcm_shmclean)
set_source_list(gtmsecshr        gtmsecshr_wrapper)
set_source_list(gtmsecshr_real   gtmsecshr)
set_source_list(libgtmcrypt      gtmcrypt_ref gtmcrypt_pk_ref gtmcrypt_dbk_ref gtmcrypt_sym_ref gtmcrypt_util)
set_source_list(libgtmtls        gtm_tls_impl gtmcrypt_util)
set_source_list(libgtmshr        gtm_main)
set_source_list(lke              lke lke_cmd)
set_source_list(maskpass         maskpass gtmcrypt_util)
set_source_list(mumps            gtm)
set_source_list(mupip            mupip mupip_cmd)

#-----------------------------------------------------------------------------
# libmumps gets leftover sources, so compute the remaining list.
set(source_used_dtgbldir.c 1) # exclude unused source
set(libmumps_SOURCES "")
foreach(d ${gt_src_list})
  foreach(s ${sources_${d}})
    if(NOT source_used_${s} AND "${s}" MATCHES "\\.(c|s|si)$")
      list(APPEND libmumps_SOURCES ${d}/${s})
      set(source_used_${s} 1)
      list(APPEND sources_used ${source_dir_${d}}/${s})
    endif()
  endforeach()
endforeach()

#-----------------------------------------------------------------------------
# Generate files depending on gtm

# Copy generation routines to a working directory.
foreach(m chk2lev.m chkop.m gendash.m genout.m loadop.m loadvx.m msg.m tttgen.m tttscan.m)
  add_custom_command(
    OUTPUT gen/${m}
    DEPENDS ${GTM_SOURCE_DIR}/sr_port/${m}
    COMMAND ${CMAKE_COMMAND} -E copy ${GTM_SOURCE_DIR}/sr_port/${m} ${GTM_BINARY_DIR}/gen/${m}
    )
endforeach()

foreach(f ttt.txt opcode_def.h vxi.h)
  select_file(src ${f})
  list(APPEND tttfiles ${src})
endforeach()
set(mumps_ttt_args -run tttgen ${tttfiles})
add_custom_command(
  OUTPUT gen/ttt.c
  DEPENDS ${tttfiles}
    gen/chk2lev.m gen/chkop.m gen/gendash.m gen/genout.m gen/loadop.m
    gen/loadvx.m gen/tttgen.m gen/tttscan.m
    ${GTM_SOURCE_DIR}/sr_unix/mumps.cmake ${gen_bootstrap_depend}
  WORKING_DIRECTORY ${GTM_BINARY_DIR}/gen
  COMMAND ${CMAKE_COMMAND}
    -D gtm_dist=${gen_bootstrap_dist}
    -D gtm_tools=${GTM_SOURCE_DIR}/sr_port
    -D gtmroutines=.
    -D mumps=${gen_bootstrap_mumps}
    -D "args=${mumps_ttt_args}"
    -D output_file=ttt.log
    -P ${GTM_SOURCE_DIR}/sr_unix/mumps.cmake
  VERBATIM
  )
list(APPEND gen_bootstrap_files gen/ttt.c)

set(gen_merrors_extra gen/merrors_ansi.h)
foreach(msg
    sr_port/cmerrors.msg
    sr_port/gdeerrors.msg
    sr_port/merrors.msg
    sr_unix_gnp/cmierrors.msg
    )
  get_filename_component(name ${msg} NAME_WE)
  set(mumps_msg_args -run msg ${GTM_SOURCE_DIR}/${msg} unix)
  set(outputs gen/${name}_ctl.c ${gen_${name}_extra})
  add_custom_command(
    OUTPUT ${outputs}
    DEPENDS gen/msg.m ${GTM_SOURCE_DIR}/${msg}
            ${GTM_SOURCE_DIR}/sr_unix/mumps.cmake ${gen_bootstrap_depend}
    WORKING_DIRECTORY ${GTM_BINARY_DIR}/gen
    COMMAND ${CMAKE_COMMAND}
      -D gtm_dist=${gen_bootstrap_dist}
      -D gtm_tools=${GTM_SOURCE_DIR}/sr_port
      -D gtmroutines=.
      -D mumps=${gen_bootstrap_mumps}
      -D "args=${mumps_msg_args}"
      -P ${GTM_SOURCE_DIR}/sr_unix/mumps.cmake
    VERBATIM
    )
  list(APPEND gen_bootstrap_files ${outputs})
endforeach()

add_custom_target(gen_bootstrap ALL DEPENDS ${gen_bootstrap_files})

#-----------------------------------------------------------------------------

if(gen_xfer_desc)
  list(SORT sources_used)
  set(CMAKE_CONFIGURABLE_FILE_CONTENT "")
  foreach(src ${sources_used})
    set(CMAKE_CONFIGURABLE_FILE_CONTENT "${CMAKE_CONFIGURABLE_FILE_CONTENT}${src}\n")
  endforeach()
  foreach(inc ${includes})
    get_filename_component(absinc ${inc} REALPATH)
    list(APPEND abs_includes ${absinc})
  endforeach()
  configure_file(${CMAKE_ROOT}/Modules/CMakeConfigurableFile.in ${GTM_BINARY_DIR}/sources.list)
  add_custom_command(
    OUTPUT xfer_desc.i
    WORKING_DIRECTORY ${GTM_BINARY_DIR}
    DEPENDS ${GTM_SOURCE_DIR}/sr_unix/gen_xfer_desc.cmake
            ${GTM_BINARY_DIR}/sources.list

## fis-gtm 7.0-004

=== debian/changelog ===
fis-gtm (7.0-004-2) unstable; urgency=medium

  * Version 7.0-004 is 64 bit only thus droping support for i386

 -- Andreas Tille <tille@debian.org>  Thu, 13 Oct 2022 18:00:53 +0200

fis-gtm (7.0-004-1) unstable; urgency=medium

  * New upstream version
  * Build-Depends: gawk

 -- Andreas Tille <tille@debian.org>  Wed, 12 Oct 2022 20:27:39 +0200

fis-gtm (7.0-002-3) unstable; urgency=medium

  * Team Upload.
  * Fix name of depends on package with micro part

 -- Nilesh Patra <nilesh@debian.org>  Mon, 12 Sep 2022 05:49:13 +0000

fis-gtm (7.0-002-2) unstable; urgency=medium

  * Team upload.
  * Source-only upload.

 -- Nilesh Patra <nilesh@debian.org>  Tue, 30 Aug 2022 14:02:15 +0000

fis-gtm (7.0-002-1) unstable; urgency=medium

  [ Amul Shah ]
  * Update to GT.M V7.0-002
    Closes: #1009900
    Closes: #1011722
  * Adjust gtminstall parameters to fix installation

  [ Andreas Tille ]
  * Standards-Version: 4.6.1 (routine-update)
  * Simplify naming scheme of binary packages to just major.minor without
    the '-micro' part.
  * Adapt creation of lintian-overrides to new lintan warning syntax
  * Add some more lintian-overrides

 -- Amul Shah <Amul.Shah@fisglobal.com>  Tue, 31 May 2022 11:56:33 -0400

=== debian/control ===
Source: fis-gtm
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Amul Shah <Amul.Shah@fisglobal.com>
Section: database
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libicu-dev,
               locales,
               tcsh,
               libncurses5-dev | libncurses-dev,
               libtinfo-dev,
               gnupg,
               zlib1g-dev,
               libgcrypt20-dev | libgcrypt-dev,
               libgpgme11-dev,
               libconfig-dev,
               libssl-dev,
               linux-libc-dev,
               libelf-dev,
               gcc-multilib,
               cmake,
               gawk
Build-Conflicts: locales-all
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/fis-gtm
Vcs-Git: https://salsa.debian.org/med-team/fis-gtm.git
Homepage: http://sourceforge.net/projects/fis-gtm
Rules-Requires-Root: binary-targets

Package: fis-gtm
Architecture: amd64
Depends: ${misc:Depends},
         fis-gtm-7.0
Provides: mumps
Description: metapackage for the latest version of FIS-GT.M database
 GT.M is a database engine with scalability proven in large real-time
 transaction processing systems that have thousands of concurrent
 users, individual database file sizes to the Terabyte range (with
 virtually unlimited aggregate database sizes).  Yet the light
 footprint of GT.M allows it to also scale down for use in small
 applications and software appliances (virtual machines).
 .
 The GT.M data model is hierarchical associative memory (i.e.,
 multi-dimensional array) that imposes no restrictions on the data
 types of the indexes or content - the application logic can impose
 any schema, dictionary or data organization suited to its problem
 domain.  (Database engines that do not impose schemas, but which
 allow layered application software to impose and use whatever schema
 that is appropriate to the application are popularly referred to as
 "document oriented", "schemaless" or "schema-free" databases.)
 .
 GT.M's compiler for the standard M (also known as MUMPS) scripting
 language implements full support for ACID (Atomic, Consistent,
 Isolated, Durable) transactions, using optimistic concurrency control
 and software transactional memory (STM) that resolves the common
 mismatch between databases and programming languages. Its unique
 ability to create and deploy logical multi-site configurations of
 applications provides unrivaled continuity of business in the face of
 not just unplanned events, but also planned events, including planned
 events that include changes to application logic and schema.
 .
 This metapackage always depends from the default fis-gtm version.

Package: fis-gtm-7.0
Architecture: amd64
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libicu-dev
Recommends: zlib1g
Pre-Depends: ${misc:Pre-Depends}
Provides: gtm,
          mumps
Description: FIS-GT.M database version 7.0-002
 GT.M is a database engine with scalability proven in large real-time
 transaction processing systems that have thousands of concurrent
 users, individual database file sizes to the Terabyte range (with
 virtually unlimited aggregate database sizes).  Yet the light
 footprint of GT.M allows it to also scale down for use in small
 applications and software appliances (virtual machines).
 .
 The GT.M data model is hierarchical associative memory (i.e.,
 multi-dimensional array) that imposes no restrictions on the data
 types of the indexes or content - the application logic can impose
 any schema, dictionary or data organization suited to its problem
 domain.  (Database engines that do not impose schemas, but which
 allow layered application software to impose and use whatever schema
 that is appropriate to the application are popularly referred to as
 "document oriented", "schemaless" or "schema-free" databases.)
 .
 GT.M's compiler for the standard M (also known as MUMPS) scripting
 language implements full support for ACID (Atomic, Consistent,
 Isolated, Durable) transactions, using optimistic concurrency control
 and software transactional memory (STM) that resolves the common
 mismatch between databases and programming languages. Its unique
 ability to create and deploy logical multi-site configurations of
 applications provides unrivaled continuity of business in the face of
 not just unplanned events, but also planned events, including planned
 events that include changes to application logic and schema.

## fis-gtm 7.0-005

=== debian/changelog ===
fis-gtm (7.0-005-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS without libgcrypt-config by simply dropping the respective code
    on Debian. libgcrypt headers are installed to /usr/include on Debian
    Closes: #1071860

 -- Andreas Metzler <ametzler@debian.org>  Sat, 29 Jun 2024 15:41:01 +0200

fis-gtm (7.0-005-2) unstable; urgency=medium

  * Build-Depends: s/libgcrypt20-dev | //, pkgconf
    Closes: #1071860
  * Fix libncurses-dev Build-Depends
  * Use secure URI in debian/watch

 -- Andreas Tille <tille@debian.org>  Sat, 22 Jun 2024 21:59:20 +0200

fis-gtm (7.0-005-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 25 Dec 2022 18:28:22 +0100

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,14 @@
 Section: database
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               pkgconf,
                libicu-dev,
                locales,
                tcsh,
-               libncurses5-dev | libncurses-dev,
-               libtinfo-dev,
+               libncurses-dev,
                gnupg,
                zlib1g-dev,
-               libgcrypt20-dev | libgcrypt-dev,
+               libgcrypt-dev,
                libgpgme11-dev,
                libconfig-dev,
                libssl-dev,
@@ -22,7 +22,7 @@
                cmake,
                gawk
 Build-Conflicts: locales-all
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/fis-gtm
 Vcs-Git: https://salsa.debian.org/med-team/fis-gtm.git
 Homepage: http://sourceforge.net/projects/fis-gtm

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules for fis-gtm

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

MARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
ARCH := $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
UAPIVER := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's,+.*,,')
UAPIDIR := V$(UAPIVER)_$(ARCH)
BINPKG := $(shell awk '/Package:.*[0-9]/{print $$2;}' debian/control)
GTM_INSTALL_DIR := lib/$(MARCH)/fis-gtm/$(UAPIDIR)
LOCAL_GTM_INSTALL_DIR := $(CURDIR)/debian/$(BINPKG)/usr/$(GTM_INSTALL_DIR)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX:PATH=/usr -DGTM_INSTALL_DIR=$(GTM_INSTALL_DIR) -DCMAKE_BUILD_TYPE=Release

override_dh_auto_install:
	#echo "umask is: "
	#umask
	dh_auto_install --destdir=debian/$(BINPKG)-stage1 $@
	cd debian/$(BINPKG)-stage1/usr/$(GTM_INSTALL_DIR) && \
		gtm_destdir=$(CURDIR)/debian/$(BINPKG) \
		gtmcompile="-embed_source" \
		./gtminstall --utf8 --user root --group root --verbose \
			--noprompt-for-sys-cfg --distrib . \
			--installdir $(LOCAL_GTM_INSTALL_DIR)
	#@echo "I: Removing redundant license file. One is already available."
	find $(LOCAL_GTM_INSTALL_DIR) -name COPYING -delete
	# remove empty directories
	find $(LOCAL_GTM_INSTALL_DIR) -type d -empty -delete
	# fix permissions of directories
	find $(LOCAL_GTM_INSTALL_DIR) -type d -exec chmod u+x \{\} \;

override_dh_fixperms:
	#echo "umask is: "
	#umask
	dh_fixperms
	#echo "overriding dh_fixperms"
	#echo "I: Fixing up permissions for removed write rights -- we aren't done yet!"
	chmod +w -R $(LOCAL_GTM_INSTALL_DIR)
	chmod +w -R $(LOCAL_GTM_INSTALL_DIR)/utf8
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/utf8
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/plugin
	#echo "I: Fixing up permissions for setuid rights -- we aren't done yet!"
	chmod 4755 $(LOCAL_GTM_INSTALL_DIR)/gtmsecshr
	chmod 0500 $(LOCAL_GTM_INSTALL_DIR)/gtmsecshrdir
	chmod 4500 $(LOCAL_GTM_INSTALL_DIR)/gtmsecshrdir/gtmsecshr
	#echo "I: changing permissions to 644 for files that will be sourced"
	chmod 0644 $(LOCAL_GTM_INSTALL_DIR)/gtmprofile
	chmod 0644 $(LOCAL_GTM_INSTALL_DIR)/gtmprofile_preV54000
	chmod 0644 $(LOCAL_GTM_INSTALL_DIR)/gtcm_slist
	chmod 0644 $(LOCAL_GTM_INSTALL_DIR)/gtmcshrc
	#echo "I: Fixing executable permissions"
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/dse
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/gtcm_gnp_server
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/gtcm_pkdisp
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/gtcm_play
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/gtcm_run
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/gtcm_server
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/gtcm_shmclean
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/gtm
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/gtmbase
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/gtmstart
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/gtmstop
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/lke
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/mumps
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/mupip
	chmod 0755 $(LOCAL_GTM_INSTALL_DIR)/plugin/gtmcrypt/*.sh

	#echo "I: Final permissions after dh_fixperms"
	#ls -l $(LOCAL_GTM_INSTALL_DIR)

# yoh: although it might sound to remove write permissions for the
# deployed materials, as far as I see it, it is useless, since the
# user (root) would always be able to revert them to become writable.

# Because 'the' binary package name will change, let's just generate
# override files
# The override is needed according to upstream for GTM to generate executable 'call-in's
override_dh_lintian:
	echo "$(BINPKG) binary: shared-lib-without-dependency-information [usr/$(GTM_INSTALL_DIR)/libgtmutil.so]" >> debian/$(BINPKG).lintian-overrides
	echo "# The following permissions are really set intentionally in override_dh_fixpermissions" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): elevated-privileges 4500 root/root [usr/$(GTM_INSTALL_DIR)/gtmsecshrdir/gtmsecshr]" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): elevated-privileges 4500 root/root [usr/$(GTM_INSTALL_DIR)/utf8/gtmsecshrdir/gtmsecshr]" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): executable-is-not-world-readable 4500 [usr/$(GTM_INSTALL_DIR)/gtmsecshrdir/gtmsecshr]" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): executable-is-not-world-readable 4500 [usr/$(GTM_INSTALL_DIR)/utf8/gtmsecshrdir/gtmsecshr]" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): elevated-privileges 4755 root/root [usr/$(GTM_INSTALL_DIR)/gtmsecshr]" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): elevated-privileges 4755 root/root [usr/$(GTM_INSTALL_DIR)/utf8/gtmsecshr]" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): non-standard-dir-perm 0500 != 0755 [usr/$(GTM_INSTALL_DIR)/gtmsecshrdir/]" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): non-standard-setuid-executable-perm 4500 [usr/$(GTM_INSTALL_DIR)/gtmsecshrdir/gtmsecshr]" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): non-standard-setuid-executable-perm 4500 [usr/$(GTM_INSTALL_DIR)/utf8/gtmsecshrdir/gtmsecshr]" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): package-contains-hardlink pointing to: usr/$(GTM_INSTALL_DIR)/gtmsecshr [usr/$(GTM_INSTALL_DIR)/utf8/gtmsecshr]" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): package-contains-hardlink pointing to: usr/$(GTM_INSTALL_DIR)/gtmsecshrdir/gtmsecshr [usr/$(GTM_INSTALL_DIR)/utf8/gtmsecshrdir/gtmsecshr]" >> debian/$(BINPKG).lintian-overrides
	echo "$(BINPKG): shared-library-lacks-prerequisites [usr/$(GTM_INSTALL_DIR)/utf8/libgtmutil.so]" >> debian/$(BINPKG).lintian-overrides

	dh_lintian

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/$(BINPKG)-stage1
	rm -f debian/fis-gtm.links debian/fis-gtm-$(DEB_VERSION_UPSTREAM).lintian-overrides

## fis-gtm 7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #################################################################
 #								#
-# Copyright (c) 2012-2022 Fidelity National Information		#
+# Copyright (c) 2012-2025 Fidelity National Information		#
 # Services, Inc. and/or its subsidiaries. All rights reserved.	#
 #								#
 #	This source code contains the intellectual property	#
@@ -18,18 +18,18 @@
 endif()
 project(GTM C ASM)
 
-# Max optimization level is -O2
+# Max optimization level is -O3
 get_property(languages GLOBAL PROPERTY ENABLED_LANGUAGES)
 foreach(lang ${languages})
   get_property(flags CACHE CMAKE_${lang}_FLAGS_RELEASE PROPERTY VALUE)
-  if("${flags}" MATCHES "-O[3-9]")
-    string(REGEX REPLACE "-O[3-9]" "-O2" flags "${flags}")
+  if("${flags}" MATCHES "[ ]?-O[0-9]*[ ]?")
+    string(REGEX REPLACE "([ ]?)(-O[0-9]*)([ ]?)" "\\1-O3\\3" flags "${flags}")
     set_property(CACHE CMAKE_${lang}_FLAGS_RELEASE PROPERTY VALUE "${flags}")
   endif()
 endforeach()
 
 # Defaults
-set(version ${V7.0-005})
+set(version ${V7.1-008})
 if("${version}" STREQUAL "")
         set(version V9.9-0)
 endif()
@@ -50,9 +50,30 @@
 endif()
 
 if ( CMAKE_COMPILER_IS_GNUCC )
-    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -Wall -Wno-unused-result -Wno-parentheses -Wno-unused-value -Wno-unused-variable")
-    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -Wno-maybe-uninitialized -Wno-char-subscripts -Wno-unused-but-set-variable")
-    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -Wno-unused-function")
+    string(APPEND CMAKE_C_FLAGS " -std=c99"
+				" -Wmissing-prototypes -Wreturn-type -Wpointer-sign"
+				" -Wimplicit -Wall -Wno-unused-value -Wno-unused-function"
+				" -Wno-unused-variable"
+				" -Wno-unused-but-set-variable"
+				" -Wchar-subscripts"
+				" -Wno-unused-function -Woverflow"
+#				" -Wno-parentheses"
+				" -Werror")
+    #string(APPEND CMAKE_C_FLAGS " -Wpedantic")
+    #string(APPEND CMAKE_C_FLAGS " -Wstrict-overflow=5")
+    if(CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.8.5)
+      string(APPEND CMAKE_C_FLAGS " -Wno-unused-result")
+    else()
+      string(APPEND CMAKE_C_FLAGS " -Wno-strict-aliasing")
+      if(CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.4.7)
+        string(APPEND CMAKE_C_FLAGS " -Wno-maybe-uninitialized")
+      else()
+        string(APPEND CMAKE_C_FLAGS " -Wno-uninitialized")
+      endif()
+    endif()
+    if(CMAKE_VERSION VERSION_GREATER 3.12.99)
+      add_link_options("LINKER:-z,noexecstack")
+    endif()
 endif()
 
 set(install_permissions_script
@@ -66,6 +87,9 @@
 else()
     set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS $<$<CONFIG:Debug>:DEBUG>)
 endif()
+
+# Import packages
+find_package(PkgConfig)
 
 # Only IA64 and x86_64 architectures use this option
 set(gen_xfer_desc 0)
@@ -155,6 +179,7 @@
 include_directories(${includes})
 # We generate some uniquely-named headers in the top of the build tree.
 include_directories(${GTM_BINARY_DIR})
+include_directories("/usr/local/include")
 
 # Function to select the first instance of a given source file name
 # found in the ordered 'gt_src_list' search path.
@@ -310,23 +335,3 @@
   list(APPEND gen_bootstrap_files ${outputs})
 endforeach()
 
-add_custom_target(gen_bootstrap ALL DEPENDS ${gen_bootstrap_files})
-
-#-----------------------------------------------------------------------------
-
-if(gen_xfer_desc)
-  list(SORT sources_used)
-  set(CMAKE_CONFIGURABLE_FILE_CONTENT "")
-  foreach(src ${sources_used})
-    set(CMAKE_CONFIGURABLE_FILE_CONTENT "${CMAKE_CONFIGURABLE_FILE_CONTENT}${src}\n")
-  endforeach()
-  foreach(inc ${includes})
-    get_filename_component(absinc ${inc} REALPATH)
-    list(APPEND abs_includes ${absinc})
-  endforeach()
-  configure_file(${CMAKE_ROOT}/Modules/CMakeConfigurableFile.in ${GTM_BINARY_DIR}/sources.list)
-  add_custom_command(
-    OUTPUT xfer_desc.i
-    WORKING_DIRECTORY ${GTM_BINARY_DIR}
-    DEPENDS ${GTM_SOURCE_DIR}/sr_unix/gen_xfer_desc.cmake
-            ${GTM_BINARY_DIR}/sources.list

## fis-gtm 7.1-005

=== debian/changelog ===
fis-gtm (7.1-005-1) unstable; urgency=medium

  * New upstream version
  * Bump binary names to latest upstream major version
  * d/copyright: review

 -- Andreas Tille <tille@debian.org>  Tue, 03 Dec 2024 08:36:17 +0100

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
 Package: fis-gtm
 Architecture: amd64
 Depends: ${misc:Depends},
-         fis-gtm-7.0
+         fis-gtm-7.1
 Provides: mumps
 Description: metapackage for the latest version of FIS-GT.M database
  GT.M is a database engine with scalability proven in large real-time
@@ -62,7 +62,7 @@
  .
  This metapackage always depends from the default fis-gtm version.
 
-Package: fis-gtm-7.0
+Package: fis-gtm-7.1
 Architecture: amd64
 Multi-Arch: same
 Depends: ${shlibs:Depends},
@@ -72,7 +72,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Provides: gtm,
           mumps
-Description: FIS-GT.M database version 7.0-002
+Description: FIS-GT.M database version 7.1
  GT.M is a database engine with scalability proven in large real-time
  transaction processing systems that have thousands of concurrent
  users, individual database file sizes to the Terabyte range (with

## fis-gtm 7.1-006

=== debian/changelog ===
fis-gtm (7.1-006-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sat, 22 Feb 2025 21:27:23 +0100

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
                cmake,
                gawk
 Build-Conflicts: locales-all
-Standards-Version: 4.7.0
+Standards-Version: 4.7.1
 Vcs-Browser: https://salsa.debian.org/med-team/fis-gtm
 Vcs-Git: https://salsa.debian.org/med-team/fis-gtm.git
 Homepage: http://sourceforge.net/projects/fis-gtm

## fis-gtm 7.1-008

=== debian/changelog ===
fis-gtm (7.1-008-1) unstable; urgency=medium

  * New upstream version
    Closes: #1096634
    Closes: #1034805 (CVE-2021-44496 CVE-2021-44504 in version V7.1-002)
  * Build-Depends: libcrypt-dev
    Closes: #1106903
  * Standards-Version: 4.7.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 26 Sep 2025 07:08:54 +0200

=== debian/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
                libgcrypt-dev,
                libgpgme11-dev,
                libconfig-dev,
+               libcrypt-dev,
                libssl-dev,
                linux-libc-dev,
                libelf-dev,
@@ -22,7 +23,7 @@
                cmake,
                gawk
 Build-Conflicts: locales-all
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/fis-gtm
 Vcs-Git: https://salsa.debian.org/med-team/fis-gtm.git
 Homepage: http://sourceforge.net/projects/fis-gtm

=== debian/rules ===
--- 
+++ 
@@ -39,6 +39,8 @@
 	find $(LOCAL_GTM_INSTALL_DIR) -type d -empty -delete
 	# fix permissions of directories
 	find $(LOCAL_GTM_INSTALL_DIR) -type d -exec chmod u+x \{\} \;
+	# move some binaries from stage1 to $(BINPKG)
+	mv debian/$(BINPKG)-stage1/usr/$(GTM_INSTALL_DIR)/gtcm_* debian/$(BINPKG)/usr/$(GTM_INSTALL_DIR)
 
 override_dh_fixperms:
 	#echo "umask is: "

=== debian/watch ===
version=4
https://sf.net/fis-gtm/fis-gtm-V(\d\.\d-\d+[A-F]*)\.tar\.gz
